public class BaseConnection {
    public static Connection newConnection() {
        return new Connection();
    }

    public void close() {
        System.out.println(getClass() + " close");
    }
}

class Connection extends ConnectionWrapper implements SpecialConnection {
    public void close(int foo) {
        System.out.println(getClass() + " special close");
    }
}

class ConnectionWrapper extends BaseConnection {
    // This method, plus the fact that Connection implements an interface with a different
    // close, causes BaseConnection.close to be hidden in Connection because
    // ConnectionWrapper is not public
    public void close() {
        System.out.println(getClass() + " wrapper close");
    }
}
